%define anolis_release 3
%global apiver 2.91
%global fribidi_version 1.0.0
%global glib2_version 2.52.0
%global gnutls_version 3.2.7
%global gtk3_version 3.24.0
%global gtk4_version 4.0.1
%global icu_uc_version 4.8
%global libsystemd_version 220
%global pango_version 1.22.0
%global pcre2_version 10.21

Name:           vte291
Version:        0.74.0
Release:        %{anolis_release}%{?dist}
Summary:        Terminal emulator library

# libvte-2.91.so is generated from LGPLv2+ and MIT sources
License:        LGPLv3+ and MIT

URL:            https://wiki.gnome.org/Apps/Terminal/VTE
Source0:        https://download.gnome.org/sources/vte/0.74/vte-%{version}.tar.xz

# https://bugzilla.gnome.org/show_bug.cgi?id=711059
Patch0:         vte291-cntnr-precmd-preexec-scroll.patch
Patch1000:      0001-fix-CVE-2024-37535.patch

BuildRequires:  pkgconfig(fribidi) >= %{fribidi_version}
BuildRequires:  pkgconfig(gio-2.0) >= %{glib2_version}
BuildRequires:  pkgconfig(glib-2.0) >= %{glib2_version}
BuildRequires:  pkgconfig(gnutls) >= %{gnutls_version}
BuildRequires:  pkgconfig(gobject-2.0) >= %{glib2_version}
BuildRequires:  pkgconfig(gtk+-3.0) >= %{gtk3_version}
BuildRequires:  pkgconfig(gtk4) >= %{gtk4_version}
BuildRequires:  pkgconfig(icu-uc) >= %{icu_uc_version}
BuildRequires:  pkgconfig(libpcre2-8) >= %{pcre2_version}
BuildRequires:  pkgconfig(libsystemd) >= %{libsystemd_version}
BuildRequires:  pkgconfig(pango) >= %{pango_version}
BuildRequires:  pkgconfig(zlib)
BuildRequires:  gcc-c++
BuildRequires:  gettext
BuildRequires:  gobject-introspection-devel
BuildRequires:  gperf
BuildRequires:  gi-docgen
BuildRequires:  meson >= 0.60.0
BuildRequires:  systemd-rpm-macros
BuildRequires:  vala

Requires:       fribidi >= %{fribidi_version}
Requires:       glib2 >= %{glib2_version}
Requires:       gnutls >= %{gnutls_version}
Requires:       gtk3 >= %{gtk3_version}
Requires:       libicu >= %{icu_uc_version}
Requires:       pango >= %{pango_version}
Requires:       pcre2 >= %{pcre2_version}
Requires:       systemd-libs >= %{libsystemd_version}
Requires:       vte-profile

Conflicts:      gnome-terminal < 3.20.1-2

%description
VTE is a library implementing a terminal emulator widget for GTK+. VTE
is mainly used in gnome-terminal, but can also be used to embed a
console/terminal in games, editors, IDEs, etc.

%package        gtk4
Summary:        GTK4 terminal emulator library
# libvte-2.91.so is generated from LGPLv2+ and MIT sources
License:        LGPLv3+ and MIT
Requires:       %{name} = %{version}-%{release}
 
%description gtk4
VTE is a library implementing a terminal emulator widget for GTK 4. VTE
is mainly used in gnome-terminal, but can also be used to embed a
console/terminal in games, editors, IDEs, etc.

%package        devel
Summary:        Development files for %{name}
# vte-2.91 is generated from GPLv3+ sources, while the public headers are
# LGPLv3+
License:        GPLv3+ and LGPLv3+
Requires:       %{name} = %{version}-%{release}

%description devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

%package        gtk4-devel
Summary:        Development files for GTK 4 %{name}
# vte-2.91 is generated from GPLv3+ sources, while the public headers are
# LGPLv3+
License:        GPLv3+ and LGPLv3+
Requires:       %{name}-gtk4 = %{version}-%{release}
Requires:       %{name}-devel = %{version}-%{release}
 
%description gtk4-devel
The %{name}-gtk4-devel package contains libraries and header files for
developing GTK 4 applications that use %{name}.

# vte-profile is deliberately not noarch to avoid having to obsolete a noarch
# subpackage in the future when we get rid of the vte3 / vte291 split. Yum is
# notoriously bad when handling noarch obsoletes and insists on installing both
# of the multilib packages (i686 + x86_64) as the replacement.
%package -n     vte-profile
Summary:        Profile script for VTE terminal emulator library
License:        GPLv3+
# vte.sh was previously part of the vte3 package
Conflicts:      vte3 < 0.36.1-3

%description -n vte-profile
The vte-profile package contains a profile.d script for the VTE terminal
emulator library.

%prep
%autosetup -p1 -n vte-%{version}
%if 0%{?flatpak}
# Install user units where systemd macros expect them
sed -i -e "/^vte_systemduserunitdir =/s|vte_prefix|'/usr'|" meson.build
%endif

%build
%meson --buildtype=plain -Ddocs=true -Dgtk3=true -Dgtk4=true
%meson_build

%install
%meson_install

%find_lang vte-%{apiver}

%files -f vte-%{apiver}.lang
%license COPYING.LGPL3
%license COPYING.XTERM
%doc README.md
%{_libdir}/libvte-%{apiver}.so.0*
%dir %{_libdir}/girepository-1.0
%{_libdir}/girepository-1.0/Vte-2.91.typelib
%{_userunitdir}/vte-spawn-.scope.d

%files gtk4
%{_libdir}/libvte-%{apiver}-gtk4.so.0*
%{_libdir}/girepository-1.0/Vte-3.91.typelib

%files devel
%license COPYING.GPL3
%{_bindir}/vte-%{apiver}
%{_includedir}/vte-%{apiver}/
%{_libdir}/libvte-%{apiver}.so
%{_libdir}/pkgconfig/vte-%{apiver}.pc
%dir %{_datadir}/gir-1.0
%{_datadir}/gir-1.0/Vte-2.91.gir
%{_datadir}/glade/
%doc %{_docdir}/vte-2.91/
%dir %{_datadir}/vala
%dir %{_datadir}/vala/vapi
%{_datadir}/vala/vapi/vte-2.91.deps
%{_datadir}/vala/vapi/vte-2.91.vapi

%files gtk4-devel
%{_bindir}/vte-%{apiver}-gtk4
%{_includedir}/vte-%{apiver}-gtk4/
%{_libdir}/libvte-%{apiver}-gtk4.so
%{_libdir}/pkgconfig/vte-%{apiver}-gtk4.pc
%{_datadir}/gir-1.0/Vte-3.91.gir
%doc %{_docdir}/vte-2.91-gtk4/
%{_datadir}/vala/vapi/vte-2.91-gtk4.deps
%{_datadir}/vala/vapi/vte-2.91-gtk4.vapi

%files -n vte-profile
%license COPYING.GPL3
%{_libexecdir}/vte-urlencode-cwd
%{_sysconfdir}/profile.d/vte.csh
%{_sysconfdir}/profile.d/vte.sh

%changelog
* Wed Nov 06 2024 mgb01105731 <mgb01105731@alibaba-inc.com> - 0.74.0-3
- add patch to fix CVE-2024-37535

* Wed May 22 2024 mgb01105731 <mgb01105731@alibaba-inc.com> - 0.74.0-2
- fix source link

* Mon Sep 18 2023 Funda Wang <fundawang@yeah.net> - 0.74.0-1
- New version 0.74.0

* Mon Jul 10 2023 Funda Wang <fundawang@yeah.net> - 0.72.2-1
- New version 0.72.2

* Wed Apr 19 2023 Funda Wang <fundawang@yeah.net> - 0.72.1-1
- New version 0.72.1

* Mon Mar 20 2023 Funda Wang <fundawang@yeah.net> - 0.72.0-1
- New version 0.72.0

* Thu Feb 16 2023 Funda Wang <fundawang@yeah.net> - 0.70.3-1
- New version 0.70.3

* Sun Dec 4 2022 Funda Wang <fundawang@yeah.net> - 0.70.2-1
- New version 0.70.2
- Enable gtk4 backend

* Fri Jul 15 2022 happy_orange <songnannan@linux.alibaba.com> - 0.68.0-1
- Init pacakge from upstream
